#include<cstdio>
#include<iostream>
using namespace std;


int main()
{
  int k, b, x, y;
  cin >> k >> b >> x >> y;
  int s = 1;
  if((x + y) % 2 == (b + 1) % 2)
  {
    if(x == 1)
      s++;
    else
    {
      if(b > 1)
        b--;
      else
        b++;
    }  
    cout << s << ' ' << b << endl;
    cout.flush();
  }
  while(s < k)
  {
    if(b < k)
      b++, s++;
    else
      b--, s++;
    cout << s << ' ' << b << endl;
    cout.flush();
  }
  return 0;
}

